

import com.sonicsw.xq.XQMessageException;
import com.sonicsw.xq.XQPart;

import java.sql.Connection;
import java.sql.SQLException;
import org.json.*;


abstract public class DBMsgHandler {

	DBEntity theDBEntity = new DBEntity();

	public DBMsgHandler() {
	}


	
	public int handleJSON(XQPart prt, Connection con) 
	throws	java.io.IOException, 
			XQMessageException,
			SQLException
	{
	   // Read ProMonitor Message into a JSON Array 
		JSONObject jsonMessage = new JSONObject();	
		String sMsg = null;
		int SQLRtnCode=999;
		int recordCnt=0;

	try {
		sMsg = (String) prt.getContent();
		System.out.println ("[DBMsgHandler][handleJSON] : Successfully read in message!");
	 } catch (Exception e) {
	    throw new XQMessageException("[DBMsgHandler][handleJSON] : Problem occured while reading message content." );			
	 }
	 
	 //Now convert to a JSON object
	 try {
		 jsonMessage = new JSONObject(sMsg);
		 System.out.println ("[DBMsgHandler][handleJSON] : Successfully created JSON Object!");

	 } catch (JSONException e) {
		 System.err.println (e.toString());
		 throw new XQMessageException("[DBMsgHandler][handleJSON] : Problem occured while reading message content." );			
	  }
	 // Build array to be processed
	  try {
		  JSONObject proMonitorData = jsonMessage.getJSONObject("proMonitorData");
		  System.out.println ("[DBMsgHandler][handleJSON] : Successfully found the proMonitorData!");
   
	        //Now process the data section
	        JSONArray records = proMonitorData.getJSONArray("DBRecord");
			System.out.println ("[DBMsgHandler][handleJSON] : Successfully built an array of -"+records.length()+"- records.");
			  	        
	        for (int i=0; i < records.length(); i++) {
	        	
	           JSONObject dbRecord = records.getJSONObject(i); 

	   			SQLRtnCode=insertDBRecord(dbRecord,con);
	   			if (SQLRtnCode >0){
	   				throw new XQMessageException("[DBMsgHandler][handleJSON] : Bad SQL Return Code sent back. Code="+SQLRtnCode );			
	   			}
	   			recordCnt++;
	        }
	        return recordCnt;	
		  } catch (JSONException e) {
				 System.err.println (e.toString());
				 throw new XQMessageException("[DBMsgHandler][handleJSON] : Problem occured while creating keys array." );			
		  }

}// End handleXML (multiple Records)

	abstract protected DBEntity processDBRecords(JSONObject dbRecord) throws JSONException;
	abstract protected int insertDBRecord(JSONObject dbRecord,Connection con)throws JSONException,SQLException;

	protected boolean hasValue(String s) {
		boolean isValid = true;
		if (s == null) {
			isValid = false;
		} else if (s.length() == 0) {
			isValid = false;
		} else if (s.trim().length() == 0) {
			isValid = false;
		} else if (s.equalsIgnoreCase("null")) {
			isValid = false;
		}
		return isValid;
	}
	public static final int  SQL_DUPLICATE_KEY_CODE 	= 1062;
	public static final String  SQL_STALE_CONNECTION 	= "08S01";
	public static final String  SQL_DEADLOCK 			= "40001";
}// DBMsgHandler End
