


import java.io.ByteArrayInputStream;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.sonicsw.xq.XQMessageException;
import com.sonicsw.xq.XQPart;

import java.sql.Connection;
import java.sql.SQLException;

abstract public class DBXMLHandler {
	static Document document;
    String nodeName = null;
    String nodeValue = null;
	Node domNode= null;
	DBEntity theDBEntity = new DBEntity();

	public DBXMLHandler() {
	}


	public int handleXML(XQPart prt, Connection con) 
    		throws javax.xml.parsers.ParserConfigurationException,
    				java.io.IOException, 
    				org.xml.sax.SAXException, 
    				XQMessageException,
    				SQLException
	{
		
        javax.xml.parsers.DocumentBuilder xdb = com.sonicsw.xqimpl.util.DOMUtils.getDocumentBuilder(false);
        org.w3c.dom.Document document= xdb.parse(new org.xml.sax.InputSource(new ByteArrayInputStream(((String) prt.getContent()).getBytes())));
        document.normalize();

        Element root = document.getDocumentElement();
		
		NodeList nodes = root.getChildNodes();	
		NodeList DBRecordDodes = null;	
		int SQLRtnCode=999;
		int recordCnt=0;
		
		for (int i=0; i< nodes.getLength(); i++) {
			domNode = nodes.item(i);
			
			if (domNode.getNodeName().equalsIgnoreCase("DBRecord")){
				
				DBRecordDodes= domNode.getChildNodes();
				//Process DBRecord Elements
				SQLRtnCode=insertDBRecords(DBRecordDodes,con);
				if (SQLRtnCode >0){
				    throw new XQMessageException("[DBXMLHandler][handleXML] : Bad SQL Return Code sent back. Code="+SQLRtnCode );			
				}
				recordCnt++;
			}
		}
		return recordCnt;		
	}// End handleXML (multiple Records)

	abstract protected DBEntity processDBRecords(NodeList DBRecordNodes);
	abstract protected int insertDBRecords(NodeList DBRecordNodes,Connection con)throws SQLException;

	protected boolean hasValue(String s) {
		boolean isValid = true;
		if (s == null) {
			isValid = false;
		} else if (s.length() == 0) {
			isValid = false;
		} else if (s.trim().length() == 0) {
			isValid = false;
		}
		;
		return isValid;
	}
	public static final int  SQL_DUPLICATE_KEY_CODE 	= 1062;
	public static final String  SQL_STALE_CONNECTION 	= "08S01";
	public static final String  SQL_DEADLOCK 			= "40001";
}// DBXMLHandler End
