

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.json.JSONException;
import org.json.JSONObject;


public class JSONHandler extends DBMsgHandler{
	
	public JSONHandler() {
	}


	protected DBEntity processDBRecords(JSONObject dbRecord) throws JSONException {
		AreaDim theAreaDim = new AreaDim();
		try{
			theAreaDim.setCustomerKey(dbRecord.getString(AreaDim.AREADIM_CUSTOMER_KEY));
			//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_CUSTOMER_KEY);
	
			theAreaDim.setDBKey(dbRecord.getString(AreaDim.AREADIM_DB_KEY));
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_DB_KEY);	        	
			
			theAreaDim.setArea(dbRecord.getString(AreaDim.AREADIM_AREA));	
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_AREA);
	   
			theAreaDim.setDateKey(dbRecord.getString(AreaDim.AREADIM_DB_DATE_KEY));	
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_DB_DATE_KEY);
	   
			theAreaDim.setTimeReported(dbRecord.getString(AreaDim.AREADIM_TIME_REPORTED));	
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_TIME_REPORTED);
	
			theAreaDim.setTotalSize(dbRecord.getString(AreaDim.AREADIM_TOTAL_SIZE));	
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_TOTAL_SIZE);
			
	    	theAreaDim.setPercentFull(dbRecord.getString(AreaDim.AREADIM_PERCENT_FULL));	
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_PERCENT_FULL);
			
	    	theAreaDim.setProjectedGrowth(dbRecord.getString(AreaDim.AREADIM_PROJECTED_GROWTH));	
	    	//System.out.println("[AreaDimXMLHandler][handleXML] : Set " + AreaDim.AREADIM_PROJECTED_GROWTH);
	  	}catch (JSONException e) {
		  	throw new JSONException("[DBMsgHandler][processDBRecords] : Problem occured while setting DBRecord Elements" );			
	  	}
		return theAreaDim;
	}//End of processDBRecords


	@Override
	protected int insertDBRecord(JSONObject dbRecord,Connection con) throws SQLException, JSONException {
		int sqlcode=0;
	
		AreaDim theAreaDim= (AreaDim)processDBRecords(dbRecord);
		
		
        String sInsert =AreaDim.AREADIM_INSERT_STRING; 
        PreparedStatement ps = null;
        try {
        	                           	
        	  ps = con.prepareStatement(sInsert);

        	  ps.setString(1, theAreaDim.getCustomerKey());
        	  ps.setString(2, theAreaDim.getDBKey());
        	  ps.setString(3, theAreaDim.getArea());
        	  ps.setDate(4, theAreaDim.getDateKey());
        	  ps.setTime(5, theAreaDim.getTimeReported());
        	  ps.setDouble(6, theAreaDim.getTotalSize());
           	  ps.setDouble(7, theAreaDim.getPercentFull());
           	  ps.setDouble(8, theAreaDim.getProjectedGrowth());
           	  ps.setDate(9, theAreaDim.getDateLoaded());
           	  ps.setTime(10, theAreaDim.getTimeLoaded());

           	//System.out.println("[AreaDimXMLHandler].[insertDBRecords]: INSERT Statement="+ ps.toString() );     
            ps.executeUpdate();
        } catch (SQLException se) {
           	sqlcode=se.getErrorCode();  		
        	if (sqlcode==DBXMLHandler.SQL_DUPLICATE_KEY_CODE){
              	System.out.println("[AreaDimXMLHandler].[insertDBRecords]: Record was already in table. ***EXCEPTION WAS IGNORED*** SQL Message=" + se.getMessage() );     
         		sqlcode=0; //It is okay if the record already exists.       	
        	}else{
        		// Throw SQL Exceptions that can not be handled in the XMLHandler
        		throw se;
        	}
       }		
        return sqlcode;
 	} //End of insertDBRecords


}// AreaDimXMLHandler End
